#============================================================================================================
#
#	vOCǗW[
#	athelas.pl
#	-------------------------------------------------------------------------------------
#	2005.02.19 start
#
#============================================================================================================
package	ATHELAS;

#------------------------------------------------------------------------------------------------------------
#
#	RXgN^
#	-------------------------------------------------------------------------------------
#	@param	Ȃ
#	@return	W[IuWFNg
#
#------------------------------------------------------------------------------------------------------------
sub new
{
	my		$this = shift;
	my		($obj,%FILES,%NAMES,%EXPS,%TYPES,%VALIDS);
	
	$obj = {
		'FILE'	=> \%FILES,
		'NAME'	=> \%NAMES,
		'EXPL'	=> \%EXPS,
		'TYPE'	=> \%TYPES,
		'VALID'	=> \%VALIDS
	};
	bless($obj,$this);
	return $obj;
}

#------------------------------------------------------------------------------------------------------------
#
#	vOCǂݍ
#	-------------------------------------------------------------------------------------
#	@param	$Sys	MELKOR
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub Load
{
	my		$this = shift;
	my		($Sys) = @_;
	my		($path,@elem);
	
	# nbV
	undef($this->{'FILE'});
	undef($this->{'NAME'});
	undef($this->{'EXPL'});
	undef($this->{'TYPE'});
	undef($this->{'VALID'});
	
	$path = '.' . $Sys->Get('INFO') . '/plugins.cgi';
	
	if	(-e $path){
		open(PLUGINS,"<$path");
		while	(<PLUGINS>){
			chomp($_);
			@elem = split(/<>/,$_);
			$this->{'FILE'}->{$elem[0]}		= $elem[1];
			$this->{'NAME'}->{$elem[0]}		= $elem[2];
			$this->{'EXPL'}->{$elem[0]}		= $elem[3];
			$this->{'TYPE'}->{$elem[0]}		= $elem[4];
			$this->{'VALID'}->{$elem[0]}	= $elem[5];
		}
		close(PLUGINS);
	}
}

#------------------------------------------------------------------------------------------------------------
#
#	vOCۑ
#	-------------------------------------------------------------------------------------
#	@param	$Sys	MELKOR
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub Save
{
	my		$this = shift;
	my		($Sys) = @_;
	my		($path,$data);
	
	$path = '.' . $Sys->Get('INFO') . '/plugins.cgi';
	
	eval{
		open(PLUGINS,"+>$path");
		flock(PLUGINS,2);
		binmode(PLUGINS);
		truncate(PLUGINS,0);
		seek(PLUGINS,0,0);
		foreach	(keys %{$this->{'FILE'}}){
			$data = $_ . '<>' . $this->{FILE}->{$_};
			$data = $data . '<>' . $this->{NAME}->{$_};
			$data = $data . '<>' . $this->{EXPL}->{$_};
			$data = $data . '<>' . $this->{TYPE}->{$_};
			$data = $data . '<>' . $this->{VALID}->{$_};
			
			print PLUGINS "$data\n";
		}
		close(PLUGINS);
		chmod($Sys->Get('PM-ADM'),$path);
	};
}

#------------------------------------------------------------------------------------------------------------
#
#	vOCIDZbg擾
#	-------------------------------------------------------------------------------------
#	@param	$kind	
#	@param	$name	[h
#	@param	$pBuf	IDZbgi[obt@
#	@return	L[Zbg
#
#------------------------------------------------------------------------------------------------------------
sub GetKeySet
{
	my		$this = shift;
	my		($kind,$name,$pBuf) = @_;
	my		($key,$n);
	
	$n = 0;
	
	if	($kind eq 'ALL'){
		foreach	$key (keys %{$this->{NAME}}){
			push(@$pBuf,$key);
			$n++;
		}
	}
	else{
		foreach	$key (keys %{$this->{$kind}}){
			if	(($this->{$kind}->{$key} eq $name) || ($name eq 'ALL')){
				push(@$pBuf,$key);
				$n++;
			}
		}
	}
	
	return $n;
}

#------------------------------------------------------------------------------------------------------------
#
#	vOC擾
#	-------------------------------------------------------------------------------------
#	@param	$kind	
#	@param	$key	[UID
#	@return	[U
#
#------------------------------------------------------------------------------------------------------------
sub Get
{
	my		$this = shift;
	my		($kind,$key) = @_;
	
	return $this->{$kind}->{$key};
}

#------------------------------------------------------------------------------------------------------------
#
#	vOCݒ
#	-------------------------------------------------------------------------------------
#	@param	$id		[UID
#	@param	$kind	
#	@param	$val	ݒl
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub Set
{
	my		$this = shift;
	my		($id,$kind,$val) = @_;
	
	if	(exists($this->{$kind}->{$id})){
		$this->{$kind}->{$id} = $val;
	}
}

#------------------------------------------------------------------------------------------------------------
#
#	vOCǉ
#	-------------------------------------------------------------------------------------
#	@param	$file	vOCt@C
#	@param	$valid	LtO
#	@return	vOCID
#
#------------------------------------------------------------------------------------------------------------
sub Add
{
	my		$this = shift;
	my		($file,$valid) = @_;
	my		($id);
	
	$id = time();
	while(exists($this->{'FILE'}->{$id})){
		$id ++;
	}
	if(-e "./plugin/$file"){
		require("./plugin/$file");
		$plugin = new ZERO_PLUGIN;
		$this->{'FILE'}->{$id}	= $file;
		$this->{'NAME'}->{$id}	= $plugin->getName();
		$this->{'EXPL'}->{$id}	= $plugin->getExplanation();
		$this->{'TYPE'}->{$id}	= $plugin->getType();
		$this->{'VALID'}->{$id}	= $valid;
		return $id;
	}
	return '';
}

#------------------------------------------------------------------------------------------------------------
#
#	vOC폜
#	-------------------------------------------------------------------------------------
#	@param	$id		폜vOCID
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub Delete
{
	my		$this = shift;
	my		($id) = @_;
	
	delete($this->{'FILE'}->{$id});
	delete($this->{'NAME'}->{$id});
	delete($this->{'EXPL'}->{$id});
	delete($this->{'TYPE'}->{$id});
	delete($this->{'VALID'}->{$id});
}

#------------------------------------------------------------------------------------------------------------
#
#	vOCXV
#	-------------------------------------------------------------------------------------
#	@param	Ȃ
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub Update
{
	my		$this = shift;
	my		(@files,$file,$plugin,@buff,$exist);
	
	if(-e './plugin'){
		opendir(PLUGINS,'./plugin');
		@files = readdir(PLUGINS);
		closedir(PLUGINS);
		# vOCǉEXVt[Y
		foreach $file (@files){
			if($file =~ /^0ch_.*\.pl/){
				if($this->GetKeySet('FILE',$file,\@buff) > 0){
					require("./plugin/$file");
					$plugin = new ZERO_PLUGIN;
					$this->{'NAME'}->{$buff[0]} = $plugin->getName();
					$this->{'EXPL'}->{$buff[0]} = $plugin->getExplanation();
					$this->{'TYPE'}->{$buff[0]} = $plugin->getType();
					$plugin = undef;
				}
				else{
					$this->Add($file,0);
				}
				undef(@buff);
			}
		}
		# vOC폜t[Y
		if($this->GetKeySet('ALL','',\@buff) > 0){
			$exist = 0;
			foreach $plugin (@buff){
				foreach $file (@files){
					if($this->Get('FILE',$plugin) eq $file){
						$exist = 1;
						last;
					}
				}
				if($exist == 0){
					$this->Delete($plugin);
				}
				$exist = 0;
			}
		}
	}
	else{
		undef($this->{'FILE'});
		undef($this->{'NAME'});
		undef($this->{'EXPL'});
		undef($this->{'TYPE'});
		undef($this->{'VALID'});
	}
}

#============================================================================================================
#	Module END
#============================================================================================================
1;
