#============================================================================================================
#
#	VXeǗ - ݒ W[
#	sys.setting.pl
#	---------------------------------------------------------------------------
#	2004.02.14 start
#
#============================================================================================================
package	MODULE;

#------------------------------------------------------------------------------------------------------------
#
#	RXgN^
#	-------------------------------------------------------------------------------------
#	@param	Ȃ
#	@return	W[IuWFNg
#
#------------------------------------------------------------------------------------------------------------
sub new
{
	my		$this = shift;
	my		($obj,@LOG);
	
	$obj = {
		'LOG' => \@LOG
	};
	bless($obj,$this);
	
	return $obj;
}

#------------------------------------------------------------------------------------------------------------
#
#	\\bh
#	-------------------------------------------------------------------------------------
#	@param	$Sys	MELKOR
#	@param	$Form	SAMWISE
#	@param	$pSys	ǗVXe
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub DoPrint
{
	my		$this = shift;
	my		($Sys,$Form,$pSys) = @_;
	my		($subMode,$BASE,$Page);
	
	require('./mordor/sauron.pl');
	$BASE = new SAURON;
	
	# Ǘo^
	$Sys->Set('ADMIN',$pSys);
	
	# Ǘ}X^IuWFNg̐
	$Page		= $BASE->Create($Sys,$Form);
	$subMode	= $Form->Get('MODE_SUB');
	
	# j[̐ݒ
	SetMenuList($BASE,$pSys);
	
	if		($subMode eq 'INFO'){													# VXe
		PrintSystemInfo($Page,$Sys,$Form);
	}
	elsif	($subMode eq 'BASIC'){													# {ݒ
		PrintBasicSetting($Page,$Sys,$Form);
	}
	elsif	($subMode eq 'PERMISSION'){												# p[~bVݒ
		PrintPermissionSetting($Page,$Sys,$Form);
	}
	elsif	($subMode eq 'LIMITTER'){												# ~b^ݒ
		PrintLimitterSetting($Page,$Sys,$Form);
	}
	elsif	($subMode eq 'OTHER'){													# ̑ݒ
		PrintOtherSetting($Page,$Sys,$Form);
	}
	elsif	($subMode eq 'PLUGIN'){													# g@\ݒ
		PrintPluginSetting($Page,$Sys,$Form);
	}
	elsif	($subMode eq 'COMPLETE'){												# VXeݒ芮
		$Sys->Set('_TITLE','Process Complete');
		$BASE->PrintComplete('VXeݒ菈',$this->{'LOG'});
	}
	elsif	($subMode eq 'FALSE'){													# VXeݒ莸s
		$Sys->Set('_TITLE','Process Failed');
		$BASE->PrintError($this->{'LOG'});
	}
	
	$BASE->Print($Sys->Get('_TITLE'),1);
}

#------------------------------------------------------------------------------------------------------------
#
#	@\\bh
#	-------------------------------------------------------------------------------------
#	@param	$Sys	MELKOR
#	@param	$Form	SAMWISE
#	@param	$pSys	ǗVXe
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub DoFunction
{
	my		$this = shift;
	my		($Sys,$Form,$pSys) = @_;
	my		($subMode,$err);
	
	# Ǘo^
	$Sys->Set('ADMIN',$pSys);
	
	$subMode	= $Form->Get('MODE_SUB');
	$err		= 0;
	
	if	($subMode eq 'BASIC'){														# {ݒ
		$err = FunctionBasicSetting($Sys,$Form,$this->{'LOG'});
	}
	elsif	($subMode eq 'PERMISSION'){												# p[~bVݒ
		$err = FunctionPermissionSetting($Sys,$Form,$this->{'LOG'});
	}
	elsif	($subMode eq 'LIMITTER'){												# ݒ
		$err = FunctionLimitterSetting($Sys,$Form,$this->{'LOG'});
	}
	elsif	($subMode eq 'OTHER'){													# ̑ݒ
		$err = FunctionOtherSetting($Sys,$Form,$this->{'LOG'});
	}
	elsif	($subMode eq 'SET_PLUGIN'){												# g@\ݒ
		$err = FunctionPluginSetting($Sys,$Form,$this->{'LOG'});
	}
	elsif	($subMode eq 'UPDATE_PLUGIN'){											# g@\XV
		$err = FunctionPluginUpdate($Sys,$Form,$this->{'LOG'});
	}
	
	# ʕ\
	if	($err){
		$pSys->{'LOGGER'}->Out($Form->Get('UserName'),"SYSTEM_SETTING($subMode)",'ERROR:'.$err);
		push(@{$this->{'LOG'}},$err);
		$Form->Set('MODE_SUB','FALSE');
	}
	else{
		$pSys->{'LOGGER'}->Out($Form->Get('UserName'),"SYSTEM_SETTING($subMode)",'COMPLETE');
		$Form->Set('MODE_SUB','COMPLETE');
	}
	$this->DoPrint($Sys,$Form,$pSys);
}

#------------------------------------------------------------------------------------------------------------
#
#	j[Xgݒ
#	-------------------------------------------------------------------------------------
#	@param	$Base	SAURON
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub SetMenuList
{
	my		($Base,$pSys) = @_;
	
	$Base->SetMenu("","'sys.setting','DISP','INFO'");
	
	# VXeǗ̂
	if	($pSys->{'SECINFO'}->IsAuthority($pSys->{'USER'},0,'*')){
		$Base->SetMenu("<hr>",'');
		$Base->SetMenu("{ݒ","'sys.setting','DISP','BASIC'");
		$Base->SetMenu("p[~bVݒ","'sys.setting','DISP','PERMISSION'");
		$Base->SetMenu("~b^ݒ","'sys.setting','DISP','LIMITTER'");
		$Base->SetMenu("̑ݒ","'sys.setting','DISP','OTHER'");
		$Base->SetMenu("<hr>",'');
		$Base->SetMenu("g@\\ݒ","'sys.setting','DISP','PLUGIN'");
	}
}

#------------------------------------------------------------------------------------------------------------
#
#	VXeʂ̕\
#	-------------------------------------------------------------------------------------
#	@param	$Page	y[WReLXg
#	@param	$SYS	VXeϐ
#	@param	$Form	tH[ϐ
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub PrintSystemInfo
{
	my		($Page,$SYS,$Form) = @_;
	
	$SYS->Set('_TITLE','0ch Administrator Information');
	
	$Page->Print("<br><b>0ch BBS - Administrator Script</b>");
}

#------------------------------------------------------------------------------------------------------------
#
#	VXe{ݒʂ̕\
#	-------------------------------------------------------------------------------------
#	@param	$Page	y[WReLXg
#	@param	$SYS	VXeϐ
#	@param	$Form	tH[ϐ
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub PrintBasicSetting
{
	my		($Page,$SYS,$Form) = @_;
	my		($server,$cgi,$bbs,$info,$data,$common);
	
	$SYS->Set('_TITLE','System Base Setting');
	
	$server	= $SYS->Get('SERVER');
	$cgi	= $SYS->Get('CGIPATH');
	$bbs	= $SYS->Get('BBSPATH');
	$info	= $SYS->Get('INFO');
	$data	= $SYS->Get('DATA');
	
	$common = "onclick=\"DoSubmit('sys.setting','FUNC','BASIC');\"";
	$server = 'http://' . $ENV{'SERVER_NAME'}	if	($server eq '');
	
	$Page->Print("<center><table border=0 cellspacing=2 width=100%>");
	$Page->Print("<tr><td colspan=2>eڂݒ肵[ݒ]{^ĂB</td></tr>\n");
	$Page->Print("<tr><td colspan=2><hr></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">ғT[o</td>");
	$Page->Print("<td><input type=text size=60 name=SERVER value=\"$server\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">CGIݒufBNgi΃pXj</td>");
	$Page->Print("<td><input type=text size=60 name=CGIPATH value=\"$cgi\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">fzufBNgi΃pXj</td>");
	$Page->Print("<td><input type=text size=60 name=BBSPATH value=\"$bbs\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">VXefBNgi΃pXj</td>");
	$Page->Print("<td><input type=text size=60 name=INFO value=\"$info\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">VXef[^fBNgi΃pXj</td>");
	$Page->Print("<td><input type=text size=60 name=DATA value=\"$data\" ></td></tr>\n");
	$Page->Print("<tr><td colspan=2><hr></td></tr>\n");
	$Page->Print("<tr><td colspan=2 align=right>");
	$Page->Print("<input type=button value=\"@ݒ@\" $common></td></tr>\n");
	$Page->Print("</table>");
}

#------------------------------------------------------------------------------------------------------------
#
#	p[~bVݒʂ̕\
#	-------------------------------------------------------------------------------------
#	@param	$Page	y[WReLXg
#	@param	$SYS	VXeϐ
#	@param	$Form	tH[ϐ
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub PrintPermissionSetting
{
	my		($Page,$SYS,$Form) = @_;
	my		($datP,$txtP,$logP,$admP,$admDP,$bbsDP,$logDP);
	my		($common);
	
	$SYS->Set('_TITLE','System Permission Setting');
	
	$datP	= sprintf("%o",$SYS->Get('PM-DAT'));
	$txtP	= sprintf("%o",$SYS->Get('PM-TXT'));
	$logP	= sprintf("%o",$SYS->Get('PM-LOG'));
	$admP	= sprintf("%o",$SYS->Get('PM-ADM'));
	$stopP	= sprintf("%o",$SYS->Get('PM-STOP'));
	$admDP	= sprintf("%o",$SYS->Get('PM-ADIR'));
	$bbsDP	= sprintf("%o",$SYS->Get('PM-BDIR'));
	$logDP	= sprintf("%o",$SYS->Get('PM-LDIR'));
	
	$common = "onclick=\"DoSubmit('sys.setting','FUNC','PERMISSON');\"";
	
	$Page->Print("<center><table border=0 cellspacing=2 width=100%>");
	$Page->Print("<tr><td colspan=2>eڂݒ肵[ݒ]{^ĂB<br>");
	$Page->Print("<b>i8ilŐݒ肷邱Ɓj</b></td></tr>\n");
	$Page->Print("<tr><td colspan=2><hr></td></tr>\n");
	
	$Page->Print("<tr><td class=\"DetailTitle\">datt@Cp[~bV</td>");
	$Page->Print("<td><input type=text size=10 name=PERM_DAT value=\"$datP\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">eLXgt@Cp[~bV</td>");
	$Page->Print("<td><input type=text size=10 name=PERM_TXT value=\"$txtP\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">Ot@Cp[~bV</td>");
	$Page->Print("<td><input type=text size=10 name=PERM_LOG value=\"$logP\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">Ǘt@Cp[~bV</td>");
	$Page->Print("<td><input type=text size=10 name=PERM_ADMIN value=\"$admP\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">~Xbht@Cp[~bV</td>");
	$Page->Print("<td><input type=text size=10 name=PERM_STOP value=\"$stopP\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">ǗfBNgp[~bV</td>");
	$Page->Print("<td><input type=text size=10 name=PERM_ADMIN_DIR value=\"$admDP\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">ffBNgp[~bV</td>");
	$Page->Print("<td><input type=text size=10 name=PERM_BBS_DIR value=\"$bbsDP\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">OۑfBNgp[~bV</td>");
	$Page->Print("<td><input type=text size=10 name=PERM_LOG_DIR value=\"$logDP\" ></td></tr>\n");
	
	$Page->Print("<tr><td colspan=2><hr></td></tr>\n");
	$Page->Print("<tr><td colspan=2 align=right>");
	$Page->Print("<input type=button value=\"@ݒ@\" $common></td></tr>\n");
	$Page->Print("</table>");
}

#------------------------------------------------------------------------------------------------------------
#
#	ݒʂ̕\
#	-------------------------------------------------------------------------------------
#	@param	$Page	y[WReLXg
#	@param	$SYS	VXeϐ
#	@param	$Form	tH[ϐ
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub PrintLimitterSetting
{
	my		($Page,$SYS,$Form) = @_;
	my		(@vSYS);
	
	$SYS->Set('_TITLE','System Limitter Setting');
	
	$common = "onclick=\"DoSubmit('sys.setting','FUNC','LIMITTER');\"";
	$vSYS[0] = $SYS->Get('RESMAX');
	$vSYS[1] = $SYS->Get('SUBMAX');
	$vSYS[2] = $SYS->Get('ANKERS');
	$vSYS[3] = $SYS->Get('ERRMAX');
	
	$Page->Print("<center><table border=0 cellspacing=2 width=100%>");
	$Page->Print("<tr><td colspan=2>eڂݒ肵[ݒ]{^ĂB</td></tr>");
	$Page->Print("<tr><td colspan=2><hr></td></tr>\n");
	
	$Page->Print("<tr><td class=\"DetailTitle\">1fsubjectőێ</td>");
	$Page->Print("<td><input type=text size=10 name=SUBMAX value=\"$vSYS[1]\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">1Xbh̃Xő吔</td>");
	$Page->Print("<td><input type=text size=10 name=RESMAX value=\"$vSYS[0]\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">1X̃AJ[ő吔(0Ŗ)</td>");
	$Page->Print("<td><input type=text size=10 name=ANKERS value=\"$vSYS[2]\" ></td></tr>\n");
	$Page->Print("<tr><td class=\"DetailTitle\">G[Oőێ</td>");
	$Page->Print("<td><input type=text size=10 name=ERRMAX value=\"$vSYS[3]\" ></td></tr>\n");
	
	$Page->Print("<tr><td colspan=2><hr></td></tr>\n");
	$Page->Print("<tr><td colspan=2 align=right>");
	$Page->Print("<input type=button value=\"@ݒ@\" $common></td></tr>\n");
	$Page->Print("</table>");
}

#------------------------------------------------------------------------------------------------------------
#
#	̑ݒʂ̕\
#	-------------------------------------------------------------------------------------
#	@param	$Page	y[WReLXg
#	@param	$SYS	VXeϐ
#	@param	$Form	tH[ϐ
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub PrintOtherSetting
{
	my		($Page,$SYS,$Form) = @_;
	my		($urlLink,$linkSt,$linkEd,$pathKind,$headText,$headUrl,$FastMode);
	my		($linkChk,$pathInfo,$pathQuery,$fastMode);
	my		($common);
	
	$SYS->Set('_TITLE','System Other Setting');
	
	$urlLink	= $SYS->Get('URLLINK');
	$linkSt		= $SYS->Get('LINKST');
	$linkEd		= $SYS->Get('LINKED');
	$pathKind	= $SYS->Get('PATHKIND');
	$headText	= $SYS->Get('HEADTEXT');
	$headUrl	= $SYS->Get('HEADURL');
	$FastMode	= $SYS->Get('FASTMODE');
	
	$linkChk	= ($urlLink eq 'TRUE' ? 'checked' : '');
	$fastMode	= ($FastMode == 1 ? 'checked' : '');
	$pathInfo	= ($pathKind == 0 ? 'checked' : '');
	$pathQuery	= ($pathKind == 1 ? 'checked' : '');
	
	$common = "onclick=\"DoSubmit('sys.setting','FUNC','OTHER');\"";
	
	$Page->Print("<center><table border=0 cellspacing=2 width=100%>");
	$Page->Print("<tr><td colspan=2>eڂݒ肵[ݒ]{^ĂB</td></tr>");
	$Page->Print("<tr><td colspan=2><hr></td></tr>\n");
	
	$Page->Print("<tr bgcolor=silver><td colspan=2 class=\"DetailTitle\">wb_֘A</td></tr>\n");
	$Page->Print("<tr><td>wb_ɕ\\eLXg</td>");
	$Page->Print("<td><input type=text size=60 name=HEADTEXT value=\"$headText\" ></td></tr>\n");
	$Page->Print("<tr><td>LeLXgɓ\\郊NURL</td>");
	$Page->Print("<td><input type=text size=60 name=HEADURL value=\"$headUrl\" ></td></tr>\n");
	
	$Page->Print("<tr bgcolor=silver><td colspan=2 class=\"DetailTitle\">{URL</td></tr>\n");
	$Page->Print("<tr><td colpan=2><input type=checkbox name=URLLINK value=TRUE $linkChk>");
	$Page->Print("{URLւ̎N</td>");
	$Page->Print("<tr><td colspan=2><b>ȉNOFF̂ݗL</b></td></tr>\n");
	$Page->Print("<tr><td>@@N֎~ԑ</td>");
	$Page->Print("<td><input type=text size=2 name=LINKST value=\"$linkSt\" > ` ");
	$Page->Print("<input type=text size=2 name=LINKED value=\"$linkEd\" ></td></tr>\n");
	
	$Page->Print("<tr bgcolor=silver><td colspan=2 class=\"DetailTitle\">샂[h</td></tr>\n");
	$Page->Print("<tr><td>PATH</td>");
	$Page->Print("<td><input type=radio name=PATHKIND value=\"0\" $pathInfo>PATHINFO@");
	$Page->Print("<input type=radio name=PATHKIND value=\"1\" $pathQuery>QUERYSTRING</td></tr>\n");
	
	$Page->Print("<tr><td colpan=2><input type=checkbox name=FASTMODE value=TRUE $fastMode>");
	$Page->Print("݃[h</td>");
	
	$Page->Print("<tr><td colspan=2><hr></td></tr>\n");
	$Page->Print("<tr><td colspan=2 align=right>");
	$Page->Print("<input type=button value=\"@ݒ@\" $common></td></tr>\n");
	$Page->Print("</table>");
}

#------------------------------------------------------------------------------------------------------------
#
#	g@\ݒʂ̕\
#	-------------------------------------------------------------------------------------
#	@param	$Page	y[WReLXg
#	@param	$SYS	VXeϐ
#	@param	$Form	tH[ϐ
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub PrintPluginSetting
{
	my		($Page,$SYS,$Form) = @_;
	my		(@pluginSet,$num,$common);
	
	$SYS->Set('_TITLE','System Plugin Setting');
	$common = "onclick=\"DoSubmit('sys.setting','FUNC'";
	
	require('./module/athelas.pl');
	$Plugin = new ATHELAS;
	$Plugin->Load($SYS);
	$num = $Plugin->GetKeySet('ALL','',\@pluginSet);
	
	# g@\݂ꍇ͗LEݒʂ\
	if($num > 0){
		my	($id,$file,$name,$expl,$valid);
		
		$Page->Print("<center><table border=0 cellspacing=2 width=100%>");
		$Page->Print("<tr><td colspan=3>Lɂ@\\Ƀ`FbNĂB</td></tr>\n");
		$Page->Print("<tr><td colspan=3><hr></td></tr>\n");
		$Page->Print("<tr>");
		$Page->Print("<td class=\"DetailTitle\">Function Name</td>");
		$Page->Print("<td class=\"DetailTitle\">Explanation</td>");
		$Page->Print("<td class=\"DetailTitle\">File</td></tr>\n");
		
		foreach $id (@pluginSet){
			$file = $Plugin->Get('FILE',$id);
			$name = $Plugin->Get('NAME',$id);
			$expl = $Plugin->Get('EXPL',$id);
			$valid = $Plugin->Get('VALID',$id) == 1 ? 'checked' : '';
			$Page->Print("<tr><td><input type=checkbox name=PLUGIN_VALID value=$id $valid>");
			$Page->Print(" $name</td><td>$expl</td><td>$file</td></tr>\n");
		}
		$Page->Print("<tr><td colspan=3><hr></td></tr>\n");
		$Page->Print("<tr><td colspan=3 align=right>");
		$Page->Print("<input type=button value=\"@ݒ@\" $common,'SET_PLUGIN');\"> ");
	}
	else{
		$Page->Print("<center><table border=0 cellspacing=2 width=100%>");
		$Page->Print("<tr><td><hr></td></tr>\n");
		$Page->Print("<tr><td><b>vOC݂͑܂B</b></td></tr>\n");
		$Page->Print("<tr><td><hr></td></tr>\n");
		$Page->Print("<tr><td align=right>");
	}
	$Page->Print("<input type=button value=\"@XV@\" $common,'UPDATE_PLUGIN');\">");
	$Page->Print("</td></tr>");
	$Page->Print("</table>");
}

#------------------------------------------------------------------------------------------------------------
#
#	{ݒ
#	-------------------------------------------------------------------------------------
#	@param	$Sys	VXeϐ
#	@param	$Form	tH[ϐ
#	@param	$pLog	Op
#	@return	G[R[h
#
#------------------------------------------------------------------------------------------------------------
sub FunctionBasicSetting
{
	my		($Sys,$Form,$pLog) = @_;
	my		($SYSTEM);
	
	# `FbN
	{
		my	$SEC	= $Sys->Get('ADMIN')->{'SECINFO'};
		my	$chkID	= $SEC->IsLogin($Form->Get('UserName'),$Form->Get('PassWord'));
		
		if	(($SEC->IsAuthority($chkID,0,'*')) == 0){
			return 1000;
		}
	}
	# ̓`FbN
	{
		my	@inList = ('SERVER','CGIPATH','BBSPATH','INFO','DATA');
		if	(!$Form->IsInput(@inList)){
			return 1001;
		}
	}
	require('./module/melkor.pl');
	$SYSTEM = new MELKOR;
	$SYSTEM->Init();
	
	$SYSTEM->Set('SERVER',$Form->Get('SERVER'));
	$SYSTEM->Set('CGIPATH',$Form->Get('CGIPATH'));
	$SYSTEM->Set('BBSPATH',$Form->Get('BBSPATH'));
	$SYSTEM->Set('INFO',$Form->Get('INFO'));
	$SYSTEM->Set('DATA',$Form->Get('DATA'));
	
	$SYSTEM->Save();
	
	# O̐ݒ
	{
		push(@$pLog," {ݒ");
		push(@$pLog,"@@@ T[oF" . $Form->Get('SERVER'));
		push(@$pLog,"@@@ CGIpXF" . $Form->Get('CGIPATH'));
		push(@$pLog,"@@@ fpXF" . $Form->Get('BBSPATH'));
		push(@$pLog,"@@@ Ǘf[^tH_F" . $Form->Get('INFO'));
		push(@$pLog,"@@@ {f[^tH_F" . $Form->Get('DATA'));
	}
	return 0;
}

#------------------------------------------------------------------------------------------------------------
#
#	p[~bVݒ
#	-------------------------------------------------------------------------------------
#	@param	$Sys	VXeϐ
#	@param	$Form	tH[ϐ
#	@param	$pLog	Op
#	@return	G[R[h
#
#------------------------------------------------------------------------------------------------------------
sub FunctionPermissionSetting
{
	my		($Sys,$Form,$pLog) = @_;
	my		($SYSTEM);
	
	# `FbN
	{
		my	$SEC	= $Sys->Get('ADMIN')->{'SECINFO'};
		my	$chkID	= $SEC->IsLogin($Form->Get('UserName'),$Form->Get('PassWord'));
		
		if	(($SEC->IsAuthority($chkID,0,'*')) == 0){
			return 1000;
		}
	}
	require('./module/melkor.pl');
	$SYSTEM = new MELKOR;
	$SYSTEM->Init();
	
	$SYSTEM->Set('PM-DAT',oct($Form->Get('PM-DAT')));
	$SYSTEM->Set('PM-TXT',oct($Form->Get('PM-TXT')));
	$SYSTEM->Set('PM-LOG',oct($Form->Get('PM-LOG')));
	$SYSTEM->Set('PM-ADM',oct($Form->Get('PM-ADM')));
	$SYSTEM->Set('PM-STOP',oct($Form->Get('PM-STOP')));
	$SYSTEM->Set('PM-ADIR',oct($Form->Get('PM-ADIR')));
	$SYSTEM->Set('PM-BDIR',oct($Form->Get('PM-BDIR')));
	$SYSTEM->Set('PM-LDIR',oct($Form->Get('PM-LDIR')));
	
	$SYSTEM->Save();
	
	# O̐ݒ
	{
		push(@$pLog," {ݒ");
		push(@$pLog,"@@@ datp[~bVF" . $Form->Get('PM-DAT'));
		push(@$pLog,"@@@ txtp[~bVF" . $Form->Get('PM-TXT'));
		push(@$pLog,"@@@ logp[~bVF" . $Form->Get('PM-LOG'));
		push(@$pLog,"@@@ Ǘt@Cp[~bVF" . $Form->Get('PM-ADM'));
		push(@$pLog,"@@@ ~Xbhp[~bVF" . $Form->Get('PM-STOP'));
		push(@$pLog,"@@@ ǗDIRp[~bVF" . $Form->Get('PM-ADIR'));
		push(@$pLog,"@@@ fDIRp[~bVF" . $Form->Get('PM-BDIR'));
		push(@$pLog,"@@@ ODIRp[~bVF" . $Form->Get('PM-LDIR'));
	}
	return 0;
}

#------------------------------------------------------------------------------------------------------------
#
#	lݒ
#	-------------------------------------------------------------------------------------
#	@param	$Sys	VXeϐ
#	@param	$Form	tH[ϐ
#	@param	$pLog	Op
#	@return	G[R[h
#
#------------------------------------------------------------------------------------------------------------
sub FunctionLimitterSetting
{
	my		($Sys,$Form,$pLog) = @_;
	my		($SYSTEM);
	
	# `FbN
	{
		my	$SEC	= $Sys->Get('ADMIN')->{'SECINFO'};
		my	$chkID	= $SEC->IsLogin($Form->Get('UserName'),$Form->Get('PassWord'));
		
		if	(($SEC->IsAuthority($chkID,0,'*')) == 0){
			return 1000;
		}
	}
	require('./module/melkor.pl');
	$SYSTEM = new MELKOR;
	$SYSTEM->Init();
	
	$SYSTEM->Set('RESMAX',$Form->Get('RESMAX'));
	$SYSTEM->Set('SUBMAX',$Form->Get('SUBMAX'));
	$SYSTEM->Set('ANKERS',$Form->Get('ANKERS'));
	$SYSTEM->Set('ERRMAX',$Form->Get('ERRMAX'));
	$SYSTEM->Set('HISMAX',$Form->Get('HISMAX'));
	$SYSTEM->Set('ADMMAX',$Form->Get('ADMMAX'));
	
	$SYSTEM->Save();
	
	# O̐ݒ
	{
		push(@$pLog," {ݒ");
		push(@$pLog,"@@@ subjectő吔F" . $Form->Get('SUBMAX'));
		push(@$pLog,"@@@ Xő吔F" . $Form->Get('RESMAX'));
		push(@$pLog,"@@@ AJ[ő吔F" . $Form->Get('ANKERS'));
		push(@$pLog,"@@@ G[Oő吔F" . $Form->Get('ERRMAX'));
		push(@$pLog,"@@@ ݗő吔F" . $Form->Get('HISMAX'));
		push(@$pLog,"@@@ Ǘ샍Oő吔F" . $Form->Get('ADMMAX'));
	}
	return 0;
}

#------------------------------------------------------------------------------------------------------------
#
#	̑ݒ
#	-------------------------------------------------------------------------------------
#	@param	$Sys	VXeϐ
#	@param	$Form	tH[ϐ
#	@param	$pLog	Op
#	@return	G[R[h
#
#------------------------------------------------------------------------------------------------------------
sub FunctionOtherSetting
{
	my		($Sys,$Form,$pLog) = @_;
	my		($SYSTEM);
	
	# `FbN
	{
		my	$SEC	= $Sys->Get('ADMIN')->{'SECINFO'};
		my	$chkID	= $SEC->IsLogin($Form->Get('UserName'),$Form->Get('PassWord'));
		
		if	(($SEC->IsAuthority($chkID,0,'*')) == 0){
			return 1000;
		}
	}
	require('./module/melkor.pl');
	$SYSTEM = new MELKOR;
	$SYSTEM->Init();
	
	$SYSTEM->Set('HEADTEXT',$Form->Get('HEADTEXT'));
	$SYSTEM->Set('HEADURL',$Form->Get('HEADURL'));
	$SYSTEM->Set('URLLINK',($Form->Equal('URLLINK','on') ? 'TRUE' : 'FALSE'));
	$SYSTEM->Set('LINKST',$Form->Get('LINKST'));
	$SYSTEM->Set('LINKED',$Form->Get('LINKED'));
	$SYSTEM->Set('PATHKIND',$Form->Get('PATHKIND'));
	$SYSTEM->Set('FASTMODE',($Form->Equal('FASTMODE','on') ? 1 : 0));
	
	$SYSTEM->Save();
	
	# O̐ݒ
	{
		push(@$pLog," ̑ݒ");
		push(@$pLog,"@@@ wb_eLXgF" . $SYSTEM->Get('HEADTEXT'));
		push(@$pLog,"@@@ wb_URLF" . $SYSTEM->Get('HEADURL'));
		push(@$pLog,"@@@ URLNF" . $SYSTEM->Get('URLLINK'));
		push(@$pLog,"@@@ @JnԁF" . $SYSTEM->Get('LINKST'));
		push(@$pLog,"@@@ @IԁF" . $SYSTEM->Get('LINKED'));
		push(@$pLog,"@@@ PATHʁF" . $SYSTEM->Get('PATHKIND'));
		push(@$pLog,"@@@ [hF" . $SYSTEM->Get('FASTMODE'));
	}
	return 0;
}

#------------------------------------------------------------------------------------------------------------
#
#	vOCݒ
#	-------------------------------------------------------------------------------------
#	@param	$Sys	VXeϐ
#	@param	$Form	tH[ϐ
#	@param	$pLog	Op
#	@return	G[R[h
#
#------------------------------------------------------------------------------------------------------------
sub FunctionPluginSetting
{
	my		($Sys,$Form,$pLog) = @_;
	my		($Plugin);
	
	# `FbN
	{
		my	$SEC	= $Sys->Get('ADMIN')->{'SECINFO'};
		my	$chkID	= $SEC->IsLogin($Form->Get('UserName'),$Form->Get('PassWord'));
		
		if	(($SEC->IsAuthority($chkID,0,'*')) == 0){
			return 1000;
		}
	}
	require('./module/athelas.pl');
	$Plugin = new ATHELAS;
	$Plugin->Load($Sys);
	
	my	(@pluginSet,@validSet,$id,$valid);
	
	$Plugin->GetKeySet('ALL','',\@pluginSet);
	@validSet = $Form->GetAtArray('PLUGIN_VALID');
	
	foreach $id (@pluginSet){
		$valid = 0;
		foreach (@validSet){
			if($_ eq $id){
				$valid = 1;
				last;
			}
		}
		push(@$pLog,$Plugin->Get('NAME',$id) . " " . ($valid ? 'L' : '') . "ɐݒ肵܂B");
		$Plugin->Set($id,'VALID',$valid);
	}
	$Plugin->Save($Sys);
	
	return 0;
}

#------------------------------------------------------------------------------------------------------------
#
#	vOCXV
#	-------------------------------------------------------------------------------------
#	@param	$Sys	VXeϐ
#	@param	$Form	tH[ϐ
#	@param	$pLog	Op
#	@return	G[R[h
#
#------------------------------------------------------------------------------------------------------------
sub FunctionPluginUpdate
{
	my		($Sys,$Form,$pLog) = @_;
	my		($Plugin);
	
	# `FbN
	{
		my	$SEC	= $Sys->Get('ADMIN')->{'SECINFO'};
		my	$chkID	= $SEC->IsLogin($Form->Get('UserName'),$Form->Get('PassWord'));
		
		if	(($SEC->IsAuthority($chkID,0,'*')) == 0){
			return 1000;
		}
	}
	require('./module/athelas.pl');
	$Plugin = new ATHELAS;
	
	# ̍XVƕۑ
	$Plugin->Load($Sys);
	$Plugin->Update();
	$Plugin->Save($Sys);
	
	# O̐ݒ
	{
		push(@$pLog," vOC̍XV");
		push(@$pLog,"@vOC̍XV܂B");
	}
	return 0;
}

#============================================================================================================
#	Module END
#============================================================================================================
1;
